import React, {useState, useEffect} from 'react';
import {WhiteSpace, WingBlank, ActivityIndicator} from 'antd-mobile'
import TodoCard from '../../components/LogCard'
import TopSearch from '../../components/TopSearch';
import axiosRequest from '../../utils/request';
import Document from 'react-document-title'
import Empty from '../Empty'

const Backlog = (props) => {
    const [start, setStart] = useState(true);
    const [endT, setEndT] = useState(false);

    const [t, setT] = useState(false)
    useEffect(() => {
        setT(true)
        axiosRequest({
            method: 'post',
            url: '/idtAppServiceV6/oApp/getUnDone',
            body: {nowPage: 1, pageSize: 10},
        }).then(res => {
            setT(false);
            setStart(false)
            let result = end && res.rows ? data.concat(res.rows) : data;
            res.rows && res.rows.length >= 10 && setCurrent(1);
            setEnd(res.rows && res.rows.length >= 10)
            setData(result);
        });
    }, [])
    const [current, setCurrent] = useState(0);
    const [searchWord, setSearchWord] = useState();

    const [loading, setLoading] = useState(false);

    const [data, setData] = useState([]);

    const checkLog = (OPERATEID, UUID) => {
        props.history.push(`/blank/info/${OPERATEID}/${UUID}`)
    };
    const getData = () => {
        const pageMap ={searchWord, nowPage: current + 1, pageSize: 10};
        setLoading(true)
        axiosRequest({
            method: 'post',
            url: '/idtAppServiceV6/oApp/getUnDone',
            body: pageMap,
        }).then(res => {
            setLoading(false);
            let result = end && res.rows ? data.concat(res.rows) : data;
            res.rows && res.rows.length >= 10 ? setCurrent(current + 1) : setEndT(true);
            setEnd(res.rows && res.rows.length >= 10)
            setData(result);
        });
    };

    //下拉加载
    const [end, setEnd] = useState(true);
    const handleScroll =() => {
        let scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        let clientHeight = document.documentElement.clientHeight || document.body.clientHeight;
        let scrollHeight = document.documentElement.scrollHeight || document.body.scrollHeight;

        console.log(scrollTop, scrollHeight, clientHeight, scrollTop + clientHeight === scrollHeight)
        if(scrollHeight > clientHeight && scrollTop + clientHeight === scrollHeight) {
            getData()
        }
    }
    useEffect(() => {
        window.addEventListener('touchmove', handleScroll, true);
        return () =>  window.removeEventListener('touchmove', handleScroll, true);
    }, [data]);

    //回到顶部
    useEffect(() => {
       window.scrollTo(0, 0)
    }, [])

    const wordSearch = val => {
        setSearchWord(val);
        getData()
    };
    useEffect(() => {
        !start && getData()
    }, [searchWord]);

    console.log(loading)
    return (
        <Document title="待办">
            <WingBlank>
                <ActivityIndicator
                    toast
                    text="加载中..."
                    animating={t}
                />
                <WhiteSpace/>
                <TopSearch onSearch={wordSearch}/>
                {
                    !start && (
                        data.length > 0 ? data.map((item, index) => (
                            <div key={index}>
                                <WhiteSpace/>
                                <TodoCard data={item} onClick={() => checkLog(item.OPERATEID, item.UUID)}/>
                            </div>

                        )) : <Empty/>
                    )

                }
                <WhiteSpace/>
                {loading && endT && (
                    <div className="pos-line mb-10">
                        <ActivityIndicator/>
                        <WhiteSpace/>
                    </div>
                )}

            </WingBlank>
        </Document>
    );
};

export default Backlog;
